// C Source File
// Created 9/21/03; 7:35:37 PM

#ifndef _SHIP_C_
#define _SHIP_C_

#include "ship.h"

void moveship(SHIP *ship, int distance, int factor)
{
	if (distance > 0) {
		ship->x += getX(ship->angle, 128/distance)*factor;
		ship->y += getY(ship->angle, 128/distance)*factor;
	
	
		if (ship->x < 0 || ship->x > area_width ||
		    ship->y < 0 || ship->y > area_height) {
			ship->x -= getX(ship->angle, 128/distance)*factor;
			ship->y -= getY(ship->angle, 128/distance)*factor;
		}
	}
}

void getshipsettings(SHIP *newship, short id)
{
	newship->energy = 100;
	switch(id)
	{
		case 1:
			newship->radius = 12;
			newship->speed = 6;
			newship->energyregen = 1;
			newship->bombloss = 4;
			newship->bombdamage = 2;
			newship->shielding = .8;
			break;
		case 2:
			newship->radius = 12;
			newship->speed = 4;
			newship->energyregen = 2;
			newship->bombloss = 2;
			newship->bombdamage = 2;
			newship->shielding = .6;
			break;
		case 3:
			newship->radius = 8;
			newship->speed = 8;
			newship->energyregen = 3;
			newship->bombloss = 1;
			newship->bombdamage = 1;	
			newship->shielding = 1;
			break;
		case 4:
			newship->radius = 12;
			newship->speed = 3;
			newship->energyregen = 1;
			newship->bombloss = 8;
			newship->bombdamage = 7;	
			newship->shielding = .3;
			break;
	}
}

SHIP chooseship(char *screen, int *shipid, const char *str)
{
	SCREEN_DIM dimensions = SetDimensions(	0, 0, 160, 100	);

	int id = 1, done=0;
	
	int angle = 0;
	
	short shiplen;
	short *shipdesign;

	short change=0;
	
	shipdesign = getdesign(id, &shiplen);

	char titlebuf[32];
	sprintf(titlebuf, "Choose %s ship", str);

	int key;

	while (!done)
	{
		ClearGrayScreen2B(GrayDBufGetPlane(GrayDBufGetHiddenIdx(), LIGHT_PLANE), GrayDBufGetPlane(GrayDBufGetHiddenIdx(), DARK_PLANE));
		
		GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);
		DrawStr(0,0,titlebuf,A_NORMAL);

		GrayDBufSetHiddenAMSPlane(DARK_PLANE);
		DrawStr(0,0,titlebuf,A_NORMAL);

		angle+=5;

		DrawShip(20,30,12,angle,&dimensions,shipdesign, shiplen);
		
		GrayDBufSetHiddenAMSPlane(DARK_PLANE);
		
		switch(id)
		{
			case 1:
				DrawStr(0,50,"Speed:         Med-Fast",A_NORMAL);
				DrawStr(0,58,"Energy Regen:  Low",A_NORMAL);
				DrawStr(0,66,"Energy Consum: High",A_NORMAL);
				DrawStr(0,74,"Weapon Damage: Medium",A_NORMAL);
				DrawStr(0,82,"Sheilding:     Weak",A_NORMAL);
				break;
			case 2:
				DrawStr(0,50,"Speed:         Medium",A_NORMAL);
				DrawStr(0,58,"Energy Regen:  Medium",A_NORMAL);
				DrawStr(0,66,"Energy Consum: Medium",A_NORMAL);
				DrawStr(0,74,"Weapon Damage: Medium",A_NORMAL);
				DrawStr(0,82,"Sheilding:     Med-Weak",A_NORMAL);
				break;
			case 3:
				DrawStr(0,50,"Speed:         Fast",A_NORMAL);
				DrawStr(0,58,"Energy Regen:  Fast",A_NORMAL);
				DrawStr(0,66,"Energy Consum: Low",A_NORMAL);
				DrawStr(0,74,"Weapon Damage: Low",A_NORMAL);
				DrawStr(0,82,"Sheilding:     None",A_NORMAL);
				break;
			case 4:
				DrawStr(0,50,"Speed:         Slow",A_NORMAL);
				DrawStr(0,58,"Energy Regen:  Low",A_NORMAL);
				DrawStr(0,66,"Energy Consum: High",A_NORMAL);
				DrawStr(0,74,"Weapon Damage: High",A_NORMAL);
				DrawStr(0,82,"Sheilding:     Heavy",A_NORMAL);
				break;
		}
			
		GrayDBufToggleSync();
		
		if (kbhit ())
		{
		  key = ngetchx ();

			if (key == KEY_ENTER)
				done = 1;

			change=0;
			if (key == KEY_LEFT) {
				id--;
				change=1;
			}
			
			if (key == KEY_RIGHT) {
				id++;
				change=1;
			}

		}

		if (id < 1)
			id = 1;
			
		if (id > 4)
			id = 4; 

		if (change)
			shipdesign = getdesign(id, &shiplen);			
	}
	
	SHIP newship;
	getshipsettings(&newship, id);
	
	*shipid = id;
	
	return newship;
}

short checkhit(BOMB *bomb, SHIP *ship)
{
	if (!bomb->enabled)
		return 0;

	if (distance(bomb->x, bomb->y, ship->x, ship->y) < ship->radius)
		return 1;
	
	return 0;
}

#endif